function Walenty(data) {
  console.log(data);
  // this.showHTML();
}

Walenty.prototype.showHTML = function(tag) {
  let data = this.getData('schemata'),
      dataSemantic = this.getData('meanings');

  $('#lexpelement_walenty').after('<div id="lexpelement_walenty_content"></div>');

  $('#lexpelement_walenty_content').append('<h2 class="header-title"><span lang="pl">Schematy</span><span lang="en">Schemes</span></h2>');
  $('#lexpelement_walenty_content').append('<div class="decoration"></div>');
  for (let i = data.length - 1; i >= 0; i--) {
    this.makeTable(data[i], i);
  }

  $('#lexpelement_walenty_content').append('<h2 class="header-title"><span lang="pl">Przykłady</span><span lang="en">Examples</span></h2>');
  $('#lexpelement_walenty_content').append('<div class="decoration"></div>');
  this.getStrayExamples();
}

Walenty.prototype.getData = function(value) {
  let editor = ace.edit("lexpelement_walenty"),
      code = editor.getValue(),
      lines = editor.session.doc.getAllLines(),
      dataArray = new Array(),
      jsonText = JSON.parse(code);
  return jsonText[value];
}

Walenty.prototype.makeTable = function(data, counter) {
  let tdSchema = '',
      tdTitle = '',
      tdData = '',
      self = this;

  // console.log(data);

  // Text_rep
  let splittedArray = '',
      splittedArray2 = '';

  if (data.text_rep.indexOf('imperf: ') > -1) {
    splittedArray = data.text_rep.split("imperf: ");
    if (splittedArray[1].indexOf(' + ') > -1) {
      splittedArray2 = splittedArray[1].split(" + ");
    }
  } else if (data.text_rep.indexOf(': ') > -1) {
    splittedArray = data.text_rep.split(": ");
    if (splittedArray[1].indexOf(' + ') > -1) {
      splittedArray2 = splittedArray[1].split(" + ");
    }
  }

  let filteredArray = [];
  splittedArray.forEach(function(singleData, i) {
    if (singleData.indexOf('{') > -1) {
      if (singleData.indexOf(' + ') > -1) {
        singleData.split(' + ').forEach(function(data, i) {
          filteredArray.push(data);
        });
      } else {
        filteredArray.push(singleData);
      }
    }
  });

  if (splittedArray2 != '') {
    splittedArray2.forEach(function(singleData, i) {
      tdTitle += '<td class="td-data">' + singleData.substring(0, singleData.indexOf('{')) + '</td>';
      tdData += '<td class="td-data">' + singleData.substring(singleData.indexOf('{') + 1, singleData.length - 1) + '</td>';
    });
  } else {
    filteredArray.forEach(function(singleData, i) {
      if (singleData.indexOf('{') > -1) {
        tdTitle += '<td class="td-data">' + singleData.substring(0, singleData.indexOf('{')) + '</td>';
        tdData += '<td class="td-data">' + singleData.substring(singleData.indexOf('{') + 1, singleData.length - 1) + '</td>';
      }
    });
  }

  //Phrases
  let colSpanner = splittedArray2.length,
      schemaName = data.opinion;

  switch (data.opinion) {
    case 'cer':
      schemaName = "pewny";
      break;
    case 'col':
      schemaName = "potoczny";
      break;
    case 'unc':
      schemaName = "potoczny";
      break;
    default:
      schemaName = '?';
  }

  let = schemaNameIdPositionStart = data.id.indexOf('.'),
        schemaNameIdPositionEnd = data.id.indexOf('-'),
        schemaNameId = data.id.substring(schemaNameIdPositionStart + 1, schemaNameIdPositionEnd);
  schemaName += ' [' + schemaNameId + ']';

  tdSchema = '<td id="schema-' + counter + '" class="td-data" colspan="' + colSpanner +'">' + schemaName + '<span class="check-icon"></span>' + '</td>';
  let phrasesArr = new Array();
  data.positions.forEach(function(singleData) {
    singleData.phrases.forEach(function(singleData2) {
      phrasesArr.push('#' + singleData2.id);
    });
  });

  let tableData =
    '<div class="table-responsive">' +
      '<table class="table table-bordered">' +
        '<tbody>' +
          '<tr>' +
            '<td class="td-header"><span lang="pl">Schemat</span><span lang="en">Scheme</span></td>' +
            tdSchema +
          '</tr>' +
          '<tr>' +
            '<td class="td-header"><span lang="pl">Funkcja</span><span lang="en">Function</span></td>' +
            tdTitle +
          '</tr>' +
          '<tr>' +
            '<td class="td-header"><span lang="pl">Typy fraz</span><span lang="en">Types of phrases</span></td>' +
            tdData +
          '</tr>' +
        '</tbody>' +
      '</table>' +
    '</div>' +
    '<div id="info-schema-' + counter + '"></div>';

  $('#lexpelement_walenty_content').append(tableData);

  $('#schema-' + counter).bind('click', function() {
    let id = $(this).attr('id');
    console.log(phrasesArr);
    let examples = self.getData('examples'),
        tdExample = '',
        checkArr = new Array();

    for (let i = 0; i < examples.length; i++) {
      for (let j = 0; j < examples[i].phraseRefs.length; j++) {
        if (phrasesArr.includes(examples[i].phraseRefs[j])) {
          if (!checkArr.includes(examples[i].sentence)) {
            checkArr.push(examples[i].sentence);
            let = positionStart = examples[i].id.indexOf('.'),
                  positionEnd = examples[i].id.indexOf('-');
                  exampleID = examples[i].id.substring(positionStart + 1, positionEnd);

            tdExampleID = '<td class="td-example-data">' + exampleID + '</td>';
            tdExampleSentence = '<td class="td-example-data">' + examples[i].sentence + '</td>';
            tdExampleSource = '<td class="td-example-data">' + examples[i].source + '</td>';
            tdExampleOpinion = '<td class="td-example-data">' + examples[i].opinion + '</td>';
            tdExample += '<tr>' + tdExampleID + tdExampleSentence + tdExampleSource + tdExampleOpinion + '</tr>';
          }
        }
      }
    }

    let tableExampleData =
      '<div class="table-responsive">' +
        '<table class="table table-bordered">' +
          '<thead>' +
            '<tr>' +
              '<td class="td-header"><span lang="pl">Identyfikator</span><span lang="en">ID</span></td>' +
              '<td class="td-header"><span lang="pl">Przykład</span><span lang="en">Example</span></td>' +
              '<td class="td-header"><span lang="pl">Źródło</span><span lang="en">Source</span></td>' +
              '<td class="td-header"><span lang="pl">Ocena</span><span lang="en">Rating</span></td>' +
            '</tr>' +
          '</thead>' +
          '<tbody>' +
              tdExample +
          '</tbody>' +
        '</table>' +
      '</div>';

    $('[id^="info-schema"]').each(function() {
      $(this).empty();
    });

    if (tdExample == "") {
      $('#info-' + id).empty();
      console.log('Brak przykładów');
    } else {
      $('#info-' + id).empty().append(tableExampleData);
    }
  });
}

Walenty.prototype.getSemantic = function(data, counter) {
  let tdFrame = '',
      tdRole = '',
      tdSelectionPreferences = '',
      numberOfColumnsToSpan = 1;

  let semFrames = this.getData('semFrames');
  $(semFrames).each(function(index, element) {
    if (element.meanings.includes('#' + data.id)) {
      numberOfColumnsToSpan = element.arguments.length;
      tdFrame = '<td colspan="' + numberOfColumnsToSpan + '" class="td-data">DODAC POTOCZNA ALBO PEWNA .. [' + element.id.substring(element.id.indexOf('_') + 1, element.id.indexOf('-')) + ']</td>';

      $(element.arguments).each(function(index, element) {
        let selectionPreferenceTd = '-';
        tdRole += '<td class="td-data">' + element.role + '</td>';
        if (element.predefs[0]) {
          selectionPreferenceTd = element.predefs[0];
        }
        tdSelectionPreferences += '<td class="td-data">' + selectionPreferenceTd + '</td>';
      });
    }
  });

  let thTitle = data.name + '-' + data.variant;
  let titleSpan = numberOfColumnsToSpan + 1;
  if (numberOfColumnsToSpan == 1) {
    titleSpan = numberOfColumnsToSpan;
  }

  let tableData =
    '<div class="table-responsive">' +
      '<table class="table table-bordered">' +
        '<thead>' +
          '<tr>' +
            '<th class="td-title" colspan="' + titleSpan + '">' + thTitle + '</th>' +
          '</tr>' +
        '</thead>' +
        '<tbody>' +
          '<tr>' +
            '<td class="td-header">Rama</td>' +
            tdFrame +
          '</tr>' +
          '<tr>' +
            '<td class="td-header">Rola</td>' +
            tdRole +
          '</tr>' +
          '<tr>' +
            '<td class="td-header">Preferencje selekcyjne</td>' +
            tdSelectionPreferences +
          '</tr>' +
        '</tbody>' +
      '</table>' +
    '</div>' +
    '<div id="info-semantic-schema-' + counter + '"></div>';

  $('#lexpelement_walenty_content').append(tableData);
}

Walenty.prototype.getStrayExamples = function() {
  let examples = this.getData('examples'),
      strayExamples = '';

  $(examples).each(function(index, element) {
    if (element.meaning === null) {
      strayExamples +=
        '<tr>' +
          '<td>' + element.id.substring(element.id.indexOf('.') + 1, element.id.indexOf('-')) + '</td>' +
          '<td>' + element.sentence + '</td>' +
          '<td>' + element.source + '</td>' +
          '<td>' + element.opinion + '</td>' +
        '</tr>';
    }
  });

  let tableData =
    '<div class="table-responsive">' +
      '<table class="table table-bordered">' +
        '<thead>' +
          '<tr>' +
            '<th class="td-title"><span lang="pl">Identyfikator</span><span lang="en">ID</span></th>' +
            '<th class="td-title"><span lang="pl">Przykład</span><span lang="en">Example</span></th>' +
            '<th class="td-title"><span lang="pl">Źródło</span><span lang="en">Source</span></th>' +
            '<th class="td-title"><span lang="pl">Ocena</span><span lang="en">Rating</span></th>' +
          '</tr>' +
        '</thead>' +
        '<tbody>' +
          '<tr>' +
            strayExamples +
          '</tr>' +
        '</tbody>' +
      '</table>' +
    '</div>';

  $('#lexpelement_walenty_content').append(tableData);
}

Walenty.id = "walenty";

$(function () {
  Element.addVisualizer(Walenty.id, Walenty);

  $('#lexp_results').on('click', '#lexpresource_walenty', function() {
    if ($('#arrow-change-lexpresources_walenty').hasClass('glyphicon-chevron-down')) {
      $('#lexpelement_walenty_content').hide();
    } else {
      $('#lexpelement_walenty_content').show();
    }
  });

  $('#lexp_results').on('mouseup', '#lexpelement_walenty_content', function(event) {
    let lemma = selectWord() || '',
        lang = $('#lang').val(),
        data = new Object();

    data.lemma = lemma;
    data.lang = lang || 'pl';
    data.left = event.originalEvent.clientX - 80 || 0;
    data.top = event.originalEvent.clientY - 55 || 0;

    if (lemma.length < 10) {
      data.left = event.originalEvent.clientX - 65 || 0;
    }

    positionTooltip(data);
  });
});